diff --git a/CHANGES b/CHANGES
index 3892f0400d..11ae7fe30f 100644
--- a/CHANGES
+++ b/CHANGES
@@ -28,6 +28,7 @@ Emulation fixes:
  - GBA Video: Add missing parts of 256-color mode 0 mosaic (fixes mgba.io/i/1701)
  - GBA Video: Fix double-size OBJ wrapping in GL renderer (fixes mgba.io/i/1712)
  - GBA Video: Simplify sprite cycle counting (fixes mgba.io/i/1279)
+ - GBA Video: Add sprite cycle counting to GL (fixes mgba.io/i/1635)
  - SM83: Emulate HALT bug
 Other fixes:
  - 3DS: Fix framelimiter on newer citro3d (fixes mgba.io/i/1771)
diff --git a/src/gba/renderers/gl.c b/src/gba/renderers/gl.c
index b75d91b2d8..311ae9c8c8 100644
--- a/src/gba/renderers/gl.c
+++ b/src/gba/renderers/gl.c
@@ -1418,6 +1418,7 @@ void _drawScanlines(struct GBAVideoGLRenderer* glRenderer, int y) {
 
 	GBAVideoGLRendererDrawWindow(glRenderer, y);
 	if (GBARegisterDISPCNTIsObjEnable(glRenderer->dispcnt) && !glRenderer->d.disableOBJ) {
+		int spriteCyclesRemaining = GBARegisterDISPCNTIsHblankIntervalFree(glRenderer->dispcnt) ? OBJ_HBLANK_FREE_LENGTH : OBJ_LENGTH;
 		glStencilOp(GL_KEEP, GL_KEEP, GL_REPLACE);
 		glEnable(GL_STENCIL_TEST);
 		glDepthFunc(GL_LESS);
@@ -1428,6 +1429,10 @@ void _drawScanlines(struct GBAVideoGLRenderer* glRenderer, int y) {
 			}
 
 			GBAVideoGLRendererDrawSprite(glRenderer, &sprite->obj, y, sprite->y);
+			spriteCyclesRemaining -= sprite->cycles;
+			if (spriteCyclesRemaining <= 0) {
+				break;
+			}
 		}
 		glDisable(GL_DEPTH_TEST);
 		glDisable(GL_STENCIL_TEST);
